# Ultramode news.tcl V1.3  -- Generic 'to be changed' version
# by Thrill
# 
# All newsheadlines parsed by this script are (C) <whatever site you implement>
# 
# Version History: V1.0 - first public release
#                  V1.1 - minor bugfixes + XML capability
#                  V1.2 - Fixed compressed input
#                  V1.3 - Added timer to prevent hammering
# 
# Remember to change this script before implementing it! Remove/comment the 'die "Ultramode News not changed!"' afterwards.
# Change all the variables until DO NOT EDIT to reflect the site you are using. See the included example-scripts for
# amiga.org and slashdot.org for reference.
#
# The author takes no responsibility whatsoever for the usage and working of this script !
# 
# E-mail: jmildham59@hotmail.com

# default bind command !ultranews, change to your liking
set ultracommandname "!ultranews"

# do NOT change this: 
bind pub - "$ultracommandname" ultranews
# change from here again:

# set the base URL here if the ultramode.txt only shows a relative path to the newsfile (ie. not 'http://slashdot.org/newsitem' but '/newsitem')
# for slashdot this stays empty - for amiga.org this gets 'http://www.amiga.org'
set ultrabaseurl ""

# set the location of lynx here. Normally this should be ok.
set ultralynx "/usr/bin/lynx"

# set temporary path here
set ultratemp "/tmp/ultramode.txt"

# set the URL of the ultramode.txt here 
set ultramode "http://www.mysite.org/ultramode.txt"

# change this line to what you want to appear as title of the page (single word) 
set ultratitle "Ultramode"
# the url to the page you are pasting the news from
set ultraurl "Mysite.org"

# change this to the number of newsitems to paste to the chan by default when no option is given
# do NOT make this larger then the maximum of newsitems than there are in ultramode.txt !
set ultraitems 4

# change this to the maximum number of newsitems there are in ultramode.txt, by default this is 10
set ultramaxitems 10

# change this to allow the script to handle compressed url's 
# if the script does not seem to work, set this to 1
# it *has* to be set to 1 for slashdot.org
set ultracompressed 0

# change this to (the full path of) your "gunzip" command, only necessary when ultracompressed is set to 1
# the default assumes gunzip is in your path
set ultragunzip "gunzip"

# number of seconds which the scripts wait before refreshing the URL
# notice: this has to be 30+ (1800s) minutes to satisfy slashdot anti-spam rules ! you will be banned if you don't adhere to this policy !
set ultrawaitseconds 2000

# there is 1 possible changeme below in the output function (clearly noted) to let you change the way
# the newsitems are displayed.

# comment this line out after change
die "Ultramode $ultratitle News not changed!"

#### DO NOT EDIT BELOW - EVERY CHANGE IS ON YOUR OWN RISK AND COULD LEAD THIS SCRIPT TO FAIL! ####

################
# Function: ultranews
# Purpose : public function called by the bind !ultranews, selects user-choice and forwards to 'ultraparse'-function
proc ultranews { nick uhost handle chan arg } {
  global ultralynx ultraitems ultramaxitems ultraurl ultramode ultratemp ultrabaseurl ultracommandname ultracompressed ultragunzip
   if {[llength $arg]==0} {
      # user gave just !ultranews
      if { $ultracompressed == 1 } {           
        set f [open "|$ultralynx -core -child -preparsed -nolist -dump $ultramode | $ultragunzip" r]
      } else {
        set f [open "|$ultralynx -core -child -preparsed -nolist -dump $ultramode" r]
      }
      set ultratempfile [open "$ultratemp" w]
      while { [eof $f] != 1 } {
        set templine "[gets $f]"
        puts $ultratempfile $templine
      }
      close $f
      close $ultratempfile
      putchan $chan "3$ultraurl Headlines (c) $ultraurl - by Thrill \"$ultracommandname help\" for options "
      for { set argument 1 } { $argument < $ultraitems+1 } { incr argument } {
        ultraparse $nick $uhost $handle $chan $argument
      }
   } else {
      if { [lindex $arg 0] == "help" } {
        # user asked for help
        putserv "notice $nick :$ultraurl News - www.$ultraurl - by Thrill"
        putserv "notice $nick :Usage: $ultracommandname <number>"
        putserv "notice $nick :where <number> is from 1 to $ultramaxitems"
      } else { 
         if { ([lindex $arg 0] < $ultramaxitems+1) && ([lindex $arg 0] > 0) } {
           putchan $chan "3$ultraurl Headlines (c) $ultraurl - by Thrill \"$ultracommandname help\" for options "
           if { $ultracompressed == 1 } {           
            set f [open "|$ultralynx -core -child -preparsed -nolist -dump $ultramode | $ultragunzip" r]
           } else {
            set f [open "|$ultralynx -core -child -preparsed -nolist -dump $ultramode" r]
           }
           set ultratempfile [open "$ultratemp" w]
           while { [eof $f] != 1 } {
             set templine "[gets $f]"
             puts $ultratempfile $templine
           }
           close $f
           close $ultratempfile
           set argument "[lindex $arg 0]"
           ultraparse $nick $uhost $handle $chan $argument
         } else {
            putserv "notice $nick :Usage: $ultracommandname <number> where <number> is from 1 to $ultramaxitems" 
         }
         
        }    
     }  
}
################
# Function: ultraparse
# Purpose : private function which actually calls lynx to get the website and parses the contents based on the 
#           selection parameter $arg. First line of the news is red.
proc ultraparse { nick uhost handle chan arg } {  
  global ultralynx ultraitems ultramaxitems ultraurl ultramode ultratemp ultrabaseurl ultracommandname
  set f [open "$ultratemp" r]
  set templine "[gets $f]"
  set countera 0
  while {[eof $f] != 1} {
    set templine "[gets $f]"
    if {$templine == "%%"} {
      incr countera
      if { $countera == $arg } {
       set templine "[gets $f]"
       set tempurl "[gets $f]"
       set tempdate "[gets $f]"
## POSSIBLE CHANGEME -> here is the output of the URL, when you leave the variables intact, you could remove the colors
## this is the version without any colours (which does look a little blurry alas):
##     if {$ultrabaseurl != ""} {
##       putchan $chan " [lindex $tempdate 0] $templine Click: $ultrabaseurl$tempurl"
##     } else {
##       putchan $chan " [lindex $tempdate 0] $templine Click: $tempurl"
##     }
############

       if {$ultrabaseurl != ""} {
         putchan $chan "3 [lindex $tempdate 0] 12$templine 5Click: $ultrabaseurl0$tempurl"
       } else {
         putchan $chan "3 [lindex $tempdate 0] 12$templine 5Click: $tempurl"
       }
       break
      }
    }
  }
  close $f
}

proc ultrarefreshurl { } {
    global ultralynx ultraitems ultramaxitems ultraurl ultramode ultratemp ultrabaseurl ultracommandname ultracompressed ultragunzip ultrawaitseconds
    # refresh url
    catch {
        if { $ultracompressed==1 } {
	    set f [open "|$ultralynx -core -child -preparsed -nolist -dump $ultramode | $ultragunzip" r]
	} else {
	    set f [open "|$ultralynx -core -child -preparsed -nolist -dump $ultramode" r]
	}
	set ultratempfile [open "$ultratemp" w]
	while { [eof $f] != 1 } {
	    set templine "[gets $f]"
	    puts $ultratempfile $templine
	}
	close $f
	close $ultratempfile
    }
    # reset the timer
    utimer $ultrawaitseconds "ultrarefreshurl"
}

proc putchan {chan msg} { putserv "PRIVMSG $chan :$msg" }

# call ultrarefreshurl once directly to initiate the timer and refresh the tempfile
utimer 1  "ultrarefreshurl"

putlog "Ultramode $ultratitle News V1.3 by Thrill - Loaded."